
declare variable $CSV := doc("converter:CSV:sep=|?flat.txt");

declare variable $states := 
(
<s state="start of customer" tag="customer"/>,
<s state="customer detail" tag="customer_detail"/>,
<s state="start of invoice" tag="invoice"/>,
<s state="invoice detail" tag="invoice_details"/>
);

declare function local:next($e as element()*, $pos as xs:integer)
{
	if($e/following::*[1]/column.1 = $states[$pos - 1]/@state) then ()
	else if($e/following::*[1]/column.1 = $states[$pos]/@state) then $e/following::*[1]
	else if($e/following::*[1]) then local:next($e/following::*[1], $pos) else ()
};


declare function local:walk($e as element()*, $pos as xs:integer)
{
	if(not($e))	then ()	else
	let $next_child		:= $e/following-sibling::row[1][column.1 = $states[$pos+1]/@state]
	let $sub_tree		:= local:walk($next_child, $pos + 1)
	let $next_sibling	:= local:next($e , $pos)
	return(
		element {$states[$pos]/@tag} {
			$e/*,
			$sub_tree
		},
		if($next_sibling) then local:walk($next_sibling, $pos)
		else ()
	)
};

<customers>{
	local:walk($CSV/table/row[1], 1)
}</customers>(: Stylus Studio meta-information - (c) 2004-2009. Progress Software Corporation. All rights reserved.

<metaInformation>
	<scenarios>
		<scenario default="yes" name="Scenario1" userelativepaths="yes" externalpreview="no" useresolver="yes" url="" outputurl="out.xml" processortype="saxon" tcpport="0" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline=""
		          additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" host="" port="0" user="" password="" validateoutput="no" validator="internal"
		          customvalidator="">
			<advancedProperties name="DocumentURIResolver" value=""/>
			<advancedProperties name="bSchemaAware" value="true"/>
			<advancedProperties name="bXml11" value="false"/>
			<advancedProperties name="CollectionURIResolver" value=""/>
			<advancedProperties name="xQueryVersion" value="1.0"/>
			<advancedProperties name="iValidation" value="0"/>
			<advancedProperties name="bExtensions" value="true"/>
			<advancedProperties name="iWhitespace" value="0"/>
			<advancedProperties name="bTinyTree" value="true"/>
			<advancedProperties name="bWarnings" value="true"/>
			<advancedProperties name="bUseDTD" value="false"/>
			<advancedProperties name="ModuleURIResolver" value=""/>
		</scenario>
	</scenarios>
	<MapperMetaTag>
		<MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no"/>
		<MapperBlockPosition></MapperBlockPosition>
		<TemplateContext></TemplateContext>
		<MapperFilter side="source"></MapperFilter>
	</MapperMetaTag>
</metaInformation>
:)